Package org.apache.bcel.generic

# Class INVOKEINTERFACE

java.lang.Object
org.apache.bcel.generic.Instruction
org.apache.bcel.generic.CPInstruction
org.apache.bcel.generic.FieldOrMethod
org.apache.bcel.generic.InvokeInstruction
org.apache.bcel.generic.INVOKEINTERFACE

All Implemented Interfaces:
  `Cloneable`, `ExceptionThrower`, `IndexedInstruction`, `LoadClass`, `StackConsumer`, `StackProducer`, `TypedInstruction`

public final class INVOKEINTERFACE extends InvokeInstruction
INVOKEINTERFACE - Invoke interface method

     Stack: ..., objectref, [arg1, [arg2 ...]] -> ...

See Also:
  - The invokeinterface instruction in The Java Virtual Machine Specification

- ## Field Summary

  ### Fields inherited from class org.apache.bcel.generic.CPInstruction

  `index`

  ### Fields inherited from class org.apache.bcel.generic.Instruction

  `length, opcode`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `INVOKEINTERFACE(int index, int nargs)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Call corresponding visitor method(s).
  `int`
  `consumeStack(ConstantPoolGen cpg)`
  Also works for instructions whose stack effect depends on the constant pool entry they reference.
  `void`
  `dump(DataOutputStream out)`
  Dump instruction as byte code to stream out.
  `int`
  `getCount()`
  The count argument according to the Java Language Specification, Second Edition.
  `Class<?>[]`
  `getExceptions()`
  `protected void`
  `initFromFile(ByteSequence bytes, boolean wide)`
  Read needed data (i.e., index) from file.
  `String`
  `toString(ConstantPool cp)`

  ### Methods inherited from class org.apache.bcel.generic.InvokeInstruction

  `getArgumentTypes, getClassName, getMethodName, getReturnType, getType, produceStack`

  ### Methods inherited from class org.apache.bcel.generic.FieldOrMethod

  `getClassType, getLoadClassType, getName, getReferenceType, getSignature`

  ### Methods inherited from class org.apache.bcel.generic.CPInstruction

  `getIndex, setIndex, toString`

  ### Methods inherited from class org.apache.bcel.generic.Instruction

  `copy, equals, getComparator, getLength, getName, getOpcode, hashCode, isValidByte, isValidShort, readInstruction, setComparator, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### INVOKEINTERFACE

    public INVOKEINTERFACE(int index, int nargs)

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Call corresponding visitor method(s). The order is: Call visitor methods of implemented interfaces first, then call methods according to the class hierarchy in descending order, i.e., the most specific visitXXX() call comes last.
    Specified by:
      `accept` in class `Instruction`
    Parameters:
      `v` - Visitor object

  - ### consumeStack

    public int consumeStack(ConstantPoolGen cpg)
    Description copied from class: `InvokeInstruction`
    Also works for instructions whose stack effect depends on the constant pool entry they reference.
    Specified by:
      `consumeStack` in interface `StackConsumer`
    Overrides:
      `consumeStack` in class `InvokeInstruction`
    Returns:
      Number of words consumed from stack by this instruction

  - ### dump

    public void dump(DataOutputStream out) throws IOException
    Dump instruction as byte code to stream out.
    Overrides:
      `dump` in class `CPInstruction`
    Parameters:
      `out` - Output stream
    Throws:
      `IOException` - Thrown when an I/O exception of some sort has occurred.

  - ### getCount

    public int getCount()
    The count argument according to the Java Language Specification, Second Edition.

  - ### getExceptions

    public Class<?>[] getExceptions()

  - ### initFromFile

    protected void initFromFile(ByteSequence bytes, boolean wide) throws IOException
    Read needed data (i.e., index) from file.
    Overrides:
      `initFromFile` in class `CPInstruction`
    Parameters:
      `bytes` - input stream
      `wide` - wide prefix?
    Throws:
      `IOException` - may be thrown if the implementation needs to read data from the file

  - ### toString

    public String toString(ConstantPool cp)
    Overrides:
      `toString` in class `InvokeInstruction`
    Returns:
      mnemonic for instruction with symbolic references resolved